/*!
 * HotPocket by BTHLabs (https://hotpocket.app/)
 * Copyright 2025-present BTHLabs <contact@bthlabs.pl> (https://bthlabs.pl/)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
((HotPocket, htmx) => {
  class BrowseAccountAppsView {
    constructor (app) {
      this.app = app;
    }
    onLoad = (event) => {
      document.addEventListener(
        'HotPocket:BrowseAccountAppsView:updateLoadMoreButton',
        this.onUpdateLoadMoreButton,
      );

      document.addEventListener(
        'HotPocket:BrowseAccountAppsView:delete',
        this.onDelete,
      );
    };
    onUpdateLoadMoreButton = (event) => {
      const button = document.querySelector('#BrowseAccountAppsView .ui-load-more-button');
      if (button) {
        if (event.detail.next_url) {
          button.setAttribute('hx-get', event.detail.next_url);
          button.classList.remove('disable');
          button.removeAttribute('disabled', true);
        } else {
          button.classList.add('disable');
          button.setAttribute('disabled', true);
        }

        htmx.process('#BrowseAccountAppsView .ui-load-more-button');
      }
    };
    onDelete = (event) => {
      if (event.detail && event.detail.pk) {
        const elementsToRemove = document.querySelectorAll(
          `[data-access-token="${event.detail.pk}"]`,
        );
        for (let elementToRemove of elementsToRemove) {
          elementToRemove.remove();
        }
      }
    };
  }

  HotPocket.addPlugin('UI.BrowseAccountAppsView', (app) => {
    return new BrowseAccountAppsView(app);
  });
})(window.HotPocket, window.htmx);
